"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.InputProvider = exports.useInput = exports.useInputByKey = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireWildcard(require("react"));

const InputContext = /*#__PURE__*/_react.default.createContext({});

const useInputByKey = key => {
  const context = (0, _react.useContext)(InputContext) || {};
  const result = context[key];
  return result === null || result === void 0 ? void 0 : result.value;
};

exports.useInputByKey = useInputByKey;

const useInput = ({
  type = `text`,
  label,
  key = `123`
}) => {
  const contextVal = useInputByKey(key) || ``;
  const [val, setVal] = (0, _react.useState)(contextVal);

  const Input = props => /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement("label", null, label), /*#__PURE__*/_react.default.createElement("input", (0, _extends2.default)({}, props, {
    type: type,
    value: val,
    onChange: e => setVal(e.target.value)
  })));

  return [Input, val];
};

exports.useInput = useInput;
const InputProvider = InputContext.Provider;
exports.InputProvider = InputProvider;