"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

exports.__esModule = true;
exports.ParentResourceProvider = exports.useParentResourceContext = void 0;

var _react = _interopRequireWildcard(require("react"));

const ParentResourceContext = /*#__PURE__*/_react.default.createContext({});

const useParentResourceContext = () => {
  const context = (0, _react.useContext)(ParentResourceContext);
  return context;
};

exports.useParentResourceContext = useParentResourceContext;

const ParentResourceProvider = ({
  data: providedData,
  children
}) => {
  const parentData = useParentResourceContext();
  const data = { ...parentData,
    ...providedData
  };
  return /*#__PURE__*/_react.default.createElement(ParentResourceContext.Provider, {
    value: data
  }, children);
};

exports.ParentResourceProvider = ParentResourceProvider;