"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

exports.__esModule = true;
exports.ResourceProvider = exports.useResourceByUUID = exports.useResource = exports.useResourceContext = void 0;

var _react = _interopRequireWildcard(require("react"));

const ResourceContext = /*#__PURE__*/_react.default.createContext([]);

const useResourceContext = () => {
  const context = (0, _react.useContext)(ResourceContext);
  return context;
};

exports.useResourceContext = useResourceContext;

const useResource = key => {
  const context = (0, _react.useContext)(ResourceContext);
  const result = context.find(c => c.resourceDefinitions._key === key);
  return result || {};
};

exports.useResource = useResource;

const useResourceByUUID = uuid => {
  const context = (0, _react.useContext)(ResourceContext);
  const result = context.find(c => c._uuid === uuid);
  return result;
};

exports.useResourceByUUID = useResourceByUUID;
const ResourceProvider = ResourceContext.Provider;
exports.ResourceProvider = ResourceProvider;