"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

exports.__esModule = true;
exports.RecipeIntroduction = exports.RecipeStep = exports.StepProvider = exports.useRecipeStep = void 0;

var _react = _interopRequireWildcard(require("react"));

const StepContext = /*#__PURE__*/_react.default.createContext({});

const useRecipeStep = () => {
  const context = (0, _react.useContext)(StepContext);
  return context;
};

exports.useRecipeStep = useRecipeStep;

const StepProvider = ({
  step,
  totalSteps,
  children
}) => /*#__PURE__*/_react.default.createElement(StepContext.Provider, {
  value: {
    step,
    totalSteps
  }
}, children);

exports.StepProvider = StepProvider;

const RecipeStep = ({
  step,
  totalSteps,
  children
}) => /*#__PURE__*/_react.default.createElement(StepProvider, {
  step: step,
  totalSteps: totalSteps
}, children);

exports.RecipeStep = RecipeStep;
const RecipeIntroduction = `div`;
exports.RecipeIntroduction = RecipeIntroduction;